/***** spin: pangen2.h *****/

char *Preamble[] = {
	"#include	<stdio.h>",
	"#include	<signal.h>",
	"#include	\"pan.h\"\n",
	"#define max(a,b) (((a)<(b)) ? (b) : (a))",
	"typedef struct Trail {",
	"	short pr;	/* process id    */",
	"	short st;	/* current state */",
	"	uchar tau;	/* status flags */",
	"	char  o_n, o_ot, o_m;", /* to save locals */
	"	short o_tt, o_To;", /* used in new_state()  */
	"	Trans *o_t;",	/* transition fct, next state   */
	"	int oval;",	/* backup value of a variable */
	"} Trail;",
	"Trail *trail, *trpt;",
	"uchar *this;\n",
	"int maxdepth=10000;",
	"uchar *SS, *LL;",
	"char *emalloc(), *malloc() /* , *memset() */;",
	"int mreached=0, done=0, errors=0;",
	"long nstates=0, recycled=0;",
	"long nlinks=0, truncs=0, loss=0;",
	"int mask, hcmp=0, loops=0, acycles=0, upto=1;",
	"int state_tables=0, fairness=0, homomorphism=0;",
	"char *hom_target, *hom_source;",
#ifdef PAIRS
	"int tree_before=0;",
#endif
	"#ifdef BITSTATE",
	"int ssize=22;",
	"#else",
	"int ssize=18;",
	"#endif",
	"int hmax=0, svmax=0, smax=0;",
#ifdef VARSTACK
	"int vmax=0;",
#endif
#ifdef GODEF
	"int cs_max=0;",
#endif
	"int Maxbody=0;",
	"uchar *noptr;		/* used by macro Pptr(x) */",
	"State  A_Root;		/* root of acceptance cycles */",
	"State	now;		/* the full state vector */",
	"Stack	*stack; 	/* for queues, processes */",
	"Svtack	*svtack;	/* for old state vectors */",
#ifdef VARSTACK
	"Varstack *varstack;	/* for old variable vals */",
#endif
#ifdef GODEF
	"CS_stack *cs_stack;	/* conflict sets */",
#endif
	"int J1, J2, j1, j2, j3, j4;",
	"int A_depth=0;\n",
	"int depth=0;\n",
	"#if SYNC",
	"#define IfNotBlocked	if (boq != -1) continue;",
	"#define UnBlock     	boq = -1",
	"#else",
	"#define IfNotBlocked	/* cannot block */",
	"#define UnBlock     	/* don't bother */",
	"#endif\n",
	0,
};
char *Tail[] = {
	"Trans *",
	"settr(a, b, c, d, t, l, ntp)",
	"	char *t;",
	"{	Trans *tmp = (Trans *) emalloc(sizeof(Trans));\n",
	"	tmp->atom = a&6;",
	"	tmp->st = b;",
	"	tmp->local = l;",
	"	tmp->tp = t;",
	"	tmp->ntp = ntp;",
	"	tmp->forw = c;",
	"	tmp->back = d;",
#ifdef GODEF
	"#ifdef VERBOSE",
	"	Moves[c] = t;",
	"#endif",
#endif
	"	return tmp;",
	"}\n",
#ifdef PAIRS
	"#define Visited 1<<12",
	"dfs(p, t, srcln)",
	"	short srcln[];",
	"{	Trans *n; char *wtyp();",
	"",
	"	if (t == 0 || (trans[p][t]->atom & Visited))",
	"	{	printf(\"%%dl\", t);",
	"		return;",
	"	}",
	"	trans[p][t]->atom |= Visited;",
	"	printf(\"%%d\\\"%%d%%s%%s\\\"d\", ",
	"		t, srcln[t],",
	"		(trans[p][t]->atom&2)?\" *\":\" \",",
	"		trans[p][t]->tp);",
	"	if (trans[p][t]->st)",
	"		dfs(p, trans[p][t]->st, srcln);",
	"	for (n = trans[p][t]->nxt; n; n = n->nxt)",
	"		dfs(p, n->st, srcln);",
	"	printf(\"u\");",
	"}\n",
	"Tree(p, strt, srcln)",
	"	short srcln[];",
	"{	printf(\"echo \");",
	"	dfs(p, strt, srcln);",
	"	printf(\" | 2.tree\\n\");",
	"}\n",
#endif
	"#ifdef JUMBO",
	"#define Visited 1<<12",
	"#define Completed 1<<13",
	"int",
	"jumbo_list(p, t)",
	"{	int all_local; Trans *n;",
	"	int nl, nxt_local;",

	"	if (t == 0) return 0;",
	"	if (trans[p][t]->atom & Visited)",
	"	{	if (trans[p][t]->atom & Completed)",
	"			return trans[p][t]->Local;",
	"		else",
	"			return 0;",
	"	}",
	"	n = trans[p][t];",
	"	n->atom |= Visited;",

	"	nxt_local = jumbo_list(p, n->st);",

	"	if (n->nxt && n->ntp != 'c')",
	"		all_local = 0;",
	"	else",
	"		all_local = n->local;",
	
	"	for (n = n->nxt; n; n = n->nxt)",
	"	{	nl = jumbo_list(p, n->st);",
	"		if (nl < nxt_local) nxt_local = nl;",
	"		if (!n->local || n->ntp != 'c') all_local = 0;",
	"	}",
	"	if (all_local != 0)",
	"		all_local  = nxt_local + 1;",
	"	trans[p][t]->Local = all_local;",
	"	trans[p][t]->atom |= Completed;",
	"	return all_local;",
	"}",
	"#endif",
	"Trans *",
	"cpytr(a)",
	"	Trans *a;",
	"{	Trans *tmp = (Trans *) emalloc(sizeof(Trans));\n",
	"	tmp->atom = a->atom;",
	"	tmp->st = a->st;",
	"	tmp->ist = a->ist;",
	"	tmp->local = a->local;",
	"	tmp->forw = a->forw;",
	"	tmp->back = a->back;",
	"	tmp->tp = a->tp;",
	"	tmp->ntp = a->ntp;",
	"	return tmp;",
	"}\n",
	"int cnt;",
	"retrans(n, m, is, srcln, reach) /* proc n, m states, is=initial state */",
	"	short srcln[];",
	"	uchar reach[];",
	"{	Trans *T0, *T1, *T2, *T3;",
	"	int i, j=0;",
	"	if (state_tables == 2)",
	"	{	printf(\"RAW proctype %%s\\n\", ",
	"			procname[n]);",
	"		for (i = 1; i < m; i++)",
	"			reach[i] = 1;",
	"#ifdef JUMBO",
	"		jumbo_list(n, is);",
	"#endif",
	"		tagtable(n, m, is, srcln, reach);",
	"		return;",
	"	}",
	"	do {	j++;",
	"		for (i = 1, cnt = 0; i < m; i++)",
	"		{	T1 = trans[n][i]->nxt;",
	"			T2 = trans[n][i];",
	"/* prescan: */		for (T0 = T1; T0; T0 = T0->nxt)",
	"/* choice inside choice */	if (trans[n][T0->st]->nxt)",
	"					break;",
	"			if (T0)",
	"			for (T0 = T1; T0; T0 = T0->nxt)",
	"			{	T3 = trans[n][T0->st];",
	"				if (!T3->nxt)",
	"				{	T2->nxt = cpytr(T0);",
	"					T2 = T2->nxt;",
	"					imed(T2, T0->st, n);",
	"					continue;",
	"				}",
	"				do {	T3 = T3->nxt;",
	"					T2->nxt = cpytr(T3);",
	"					T2 = T2->nxt;",
	"					imed(T2, T0->st, n);",
	"				} while (T3->nxt);",
	"				cnt++;",
	"			}",
	"		}",
	"#ifdef DEBUG2",
	"		printf(\"scan: %%d\\n\", cnt);",
	"#endif",
	"	} while (cnt);",
	"#ifdef DEBUG2",
	"	printf(\"%%d: AFTER1:\\n\", n);",
	"	tagtable(n, m, is, srcln, reach);",
	"#endif",
	"	for (i = 1; i < m; i++)",
	"	if (trans[n][i]->nxt)	/* optimize the list a bit */",
	"	{	T1 = trans[n][i]->nxt;",
	"		T0 = trans[n][i] = cpytr(trans[n][T1->st]);",
	"		imed(T0, T1->st, n);",
	"		for (T1 = T1->nxt; T1; T1 = T1->nxt)",
	"		{	T0->nxt = cpytr(trans[n][T1->st]);",
	"			T0 = T0->nxt;",
	"			imed(T0, T1->st, n);",
	"	}	}",
	"more:",
	"	if (state_tables",
	"	|| (homomorphism == 1 && strcmp(hom_target, procname[n]) == 0)",
	"	|| (homomorphism == 2 && strcmp(hom_source, procname[n]) == 0))",
	"	{	if (n == 0 && homomorphism == 1)",
	"			printf(\"\");",
	"		printf(\"proctype %%s%%s%%s%%s\",",
	"			homomorphism==1?\"O\":\"\",",
	"			homomorphism==2?\"R\":\"\",",
	"			procname[n],",
	"			homomorphism?\"()\\n{\\n\":\"\\n\");",
	"		for (i = 1; i < m; i++)",
	"			reach[i] = 1;",
	"#ifdef JUMBO",
	"		jumbo_list(n, is);",
	"#endif",
	"		tagtable(n, m, is, srcln, reach);",
	"		if (!state_tables)",
	"			printf(\"S0:	skip\\n}\\n\");",
	"	}",
	"	switch (homomorphism) {",
	"	case  1: homomorphism = 2; goto more;",
	"	case  2: homomorphism = 1; break;",
	"	default: break;",
	"	}",
	"}",
	"imed(T, v, n)	/* set intermediate state */",
	"	Trans *T;",
	"{	static uchar warned=0;",
	"	if (T->ist && !warned)",
	"	{	warned=1;",
	"		printf(\"warning: %%s has \", procname[n]);",
	"		printf(\"ambiguous flow ctl structures, \");",
	"		printf(\"revise model\\n\");",
	"	}",
	"	progstate[n][T->st] |= progstate[n][v];",
	"	accpstate[n][T->st] |= accpstate[n][v];",
	"	stopstate[n][T->st] |= stopstate[n][v];",
	"#ifdef DEBUG2",
	"printf(\"state %%d inherits %%d [%%d]\\n\", T->st, v, progstate[n][v]);",
	"#endif",
	"	T->ist = v;",
	"}",
	"tagtable(n, m, is, srcln, reach)",
	"	short srcln[];",
	"	uchar reach[];",
	"{",
	"	Trans *z;",
	"	if (is >= m || !trans[n][is]",
	"	||  is <= 0 || reach[is] == 0)",
	"		return;",
	"	reach[is] = 0;",
	"	if (homomorphism)",
	"	{	if (accpstate[n][is])",
	"			printf(\"accept_%%d:\\n\", is);",
	"		if (stopstate[n][is])",
	"			printf(\"end_%%d:\\n\", is);",
	"		if (progstate[n][is])",
	"			printf(\"progress_%%d:\\n\", is);",
	"		printf(\"S%%d:\", is);",
	"		if (homomorphism == 1)",
	"			printf(\"\t!trans ->\\n\");",
	"		printf(\"\tif\\n\");",
	"		for (z = trans[n][is]; z; z = z->nxt)",
	"		{	printf(\"\t:: \");",
	"			Crack(n, is, z, srcln);",
	"		}",
	"		printf(\"\tfi;\\n\");",
	"	} else",
	"		if (state_tables)",
	"		for (z = trans[n][is]; z; z = z->nxt)",
	"			crack(n, is, z, srcln);",
	"	for (z = trans[n][is]; z; z = z->nxt)",
	"		tagtable(n, m, z->st, srcln, reach);",
	"}",
	"uniq_trans(str)",
	"	char *str;",
	"{	int j;",
	"	static int n_have=0;",
	"	typedef struct HAVE {",
	"		char *s;",
	"		struct HAVE *n;",
	"	} HAVE;",
	"	HAVE *t, *tt;",
	"	static HAVE *h = 0;",
	"	for (t = h, tt = 0, j = 0; t; tt = t, t = t->n, j++)",
	"		if (strcmp(t->s, str) == 0)",
	"			return j;",
	"	t = (HAVE *) emalloc(sizeof(HAVE));",
	"	t->s = str;",
	"	if (!h)",
	"		h = t;",
	"	else",
	"		tt->n = t;",
	"	return j;",
	"}",
	"putsource(s)",
	"	char *s;",
	"{	int i;",
	"	for (i = 0; s[i]; i++)",
	"		if (s[i] == \'\\n\')",
	"			printf(\"\\\\n\");",
	"		else",
	"			putchar(s[i]);",
	"}",
	"Crack(n, j, z, srcln)",
	"	Trans *z;",
	"	short srcln[];",
	"{	int i;",
	"	if (!z) return;",
	"	i = 1+uniq_trans(z->tp);",
	"	if (z->atom & 6) i = -i;",
	"	if (strcmp(z->tp, \"(1)\") == 0)",
	"	{	printf(\"skip; goto S%%d	\", z->st);",
	"		printf(\"/* line %%3d */\\n\", srcln[j]);",
	"		return;",
	"	}",
	"#if 0",
	"	if (z->local && strcmp(z->tp, \"@\") != 0)",
	"	{	putsource(z->tp);",
	"		printf(\"; goto S%%d	\", z->st);",
	"		printf(\"/* line %%3d */\\n\", srcln[j]);",
	"		return;",
	"	}",
	"#endif",
	"	if (homomorphism == 1)",
	"		printf(\"atomic { trans = %%2d; \", i);",
	"	else /* homomorphism == 2 */",
	"		printf(\"atomic { (trans == %%2d); trans = 0; \", i);",
	"	printf(\"goto S%%d }\", z->st);",
	"	printf(\"	/* line %%3d, \", srcln[j]);",
	"	putsource(z->tp);",
	"	printf(\" */\\n\");",
	"	fflush(stdout);",
	"}",
	"crack(n, j, z, srcln)",
	"	Trans *z;",
	"	short srcln[];",
	"{	int i;",
	"	if (!z) return;",
	"#ifdef DEBUG2",
	"	printf(\"%%2d/%%2d at=%%2d st=%%2d f=%%2d b=%%2d ist=%%d loc=%%d - %%s\\n\",",
	"	n,j,z->atom,z->st,z->forw,z->back, z->ist, z->local, z->tp);",
	"#endif",
	"printf(\"\tstate %%2d --[%%2d]--> state %%2d [%%s%%s%%s%%s%%s] (%%d) line %%3d => \",",
	"	j, z->forw, z->st,",
	"	z->atom & 6 ?\"A\":\"-\",",
	"	z->local?\"L\" :\"-\",",
	"	accpstate[n][j]?\"a\" :\"-\",",
	"	stopstate[n][j]?\"e\" : \"-\",",
	"	progstate[n][j]?\"p\" : \"-\",",
	"	z->Local,",
	"	srcln[j]);",
	"	putsource(z->tp);",
	"	printf(\"\\n\");",
	"	fflush(stdout);",
	"}",
	0,
};
